unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls,
  // -- PostgreSQL ---
  UnitPostgreSQLclient;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    Button1: TButton;
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    postgreSQL : TPostgreSQL;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
    qs      : String;
    bRet    : boolean;
begin
    if(Assigned(postgreSQL))then
    begin
        // check each values are exists.
        if(LabeledEdit1.Text = '')then
            exit;
        if(LabeledEdit2.Text = '')then
            exit;
        if(LabeledEdit3.Text = '')then
            exit;
        if(LabeledEdit4.Text = '')then
            exit;

        // set up postgre SQL
        postgreSQL.propHost := LabeledEdit1.Text;
        postgreSQL.propUser := LabeledEdit2.Text;
        postgreSQL.propPassword := LabeledEdit3.Text;
        postgreSQL.propName := LabeledEdit4.Text;

        postgreSQL.sql_updateConnectParam;

        // connect to server
        qs := 'select firstname, lastname, birthdate, telefon from test_table;';
        bRet := postgreSQL.sql_select_oh_sg(qs,StringGrid1);
        if(not bRet)then
        begin
            // no tables ? make it now.
            qs :='CREATE TABLE test_table' +
                  '(' +
                  ' firstname character varying,' +
                  ' lastname character varying,' +
                  ' birthdate character varying,' +
                  ' telefon character varying' +
                  ') WITH ( OIDS = FALSE );' +
                  'ALTER TABLE test_table OWNER TO ' + LabeledEdit2.Text + ';';
            bRet := postgreSQL.sql_command(qs);
            if(not bRet)then
            begin
                // failed to create table.
                MessageBox(Self.Handle,
                           PChar(postgreSQL.lastErrorStr),
                           'Error return',
                           MB_ICONERROR);
                exit;
            end;

            // make a example values ...
            qs := 'insert into test_table values ( ''rage'' , ''kim'' , ''19771225'' , ''1231231234'' );';
            bRet := postgreSQL.sql_command(qs);
            if(not bRet)then
            begin
                // failed to create table.
                MessageBox(Self.Handle,
                           PChar(postgreSQL.lastErrorStr),
                           'Error return',
                           MB_ICONERROR);
                exit;
            end;

            qs := 'insert into test_table values ( ''johns'' , ''baby'' , ''19200101'' , ''2342342345'' );';
            bRet := postgreSQL.sql_command(qs);
            if(not bRet)then
            begin
                // failed to create table.
                MessageBox(Self.Handle,
                           PChar(postgreSQL.lastErrorStr),
                           'Error return',
                           MB_ICONERROR);
                exit;
            end;

            qs := 'select firstname, lastname, birthdate, telefon from test_table;';
            bRet := postgreSQL.sql_select_oh_sg(qs,StringGrid1);
        end;

    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    LabeledEdit1.Text := '127.0.0.1';   // localhost
    LabeledEdit2.Text := 'postgres';    // user
    LabeledEdit4.Text := 'postgres';    // DB name

    StringGrid1.Cells[0,0]:='Firstname';
    StringGrid1.Cells[1,0]:='Lastname';
    StringGrid1.Cells[2,0]:='Birthdate';
    StringGrid1.Cells[3,0]:='Telefon';

    postgreSQL := TPostgreSQL.Create(Self);
end;

end.
